#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

typedef struct node{
	int key;
	struct node *left, *right;
} node_t;

typedef struct {
	int max;  //total size
	int n;    //used size
	node_t *M; //root
} tree_t;

//adds new element to tree or ignores if already present
node_t *add(int key, node_t *p, tree_t *t){
	node_t *tmp;
	//printf("%p: %d ", p, p != NULL ? p->key : 0);
	if(p == NULL){
		tmp = malloc(sizeof(node_t));
		if(tmp == NULL){
			//printf("out of space for %d!\n\n", key);
			return NULL;
		}
		tmp->key = key;
		tmp->left = tmp->right = NULL;
		t->n++; 
		//printf("added %d\n\n", key);
		return tmp;
	}
	if(p->key > key){
		//printf("go left\n");
		if(p->left == NULL)
			p->left = add(key, NULL, t);
		else
			add(key, p->left, t);
	}
	if(p->key < key){
		//printf("go right\n");
		if(p->right == NULL)
			p->right = add(key, NULL, t);
		else
			add(key, p->right, t);
	}
	if(p->key == key){
		//printf("present %d\n\n", key);
	}
	return NULL;
}

//prints the entire tree, recursive
void print(node_t *p, int level){
	if(p == NULL)
		return;
	print(p->left, level + 1);
	printf("%*s%d\n", level * 4, "", p->key);
	//printf("(%d) %d\n", level, p->key);
	print(p->right, level + 1);
}

//frees entire tree, recursive
void freeNode(node_t *p){
	if(p == NULL)
		return;
	freeNode(p->left);
	freeNode(p->right);
	free(p);
}

int main(void){
	int n;
	printf("How many: ");
	if(scanf("%d", &n) < 1 || n < 1)
		return 0;
	printf("----------------------------------------\n\n");
	tree_t tree = {n, 0, NULL};
	int k = n * 2;
	struct timeval start, stop;
	gettimeofday(&start, NULL);
	// v // mdame seda osa let's measure this part 
	for(int i = 0; i < n; i++)
		if(tree.M == NULL)
		tree.M = add(rand() % k, NULL, &tree);
		else
			add(rand() % k, tree.M, &tree);
	// ^ // mdame seda osa  let's measure this part
	gettimeofday(&stop, NULL);
	double sec = stop.tv_sec + (stop.tv_usec / 1000000.0) - 
		( start.tv_sec + start.tv_usec / 1000000.0);
	printf("Time\t%12.6f\n", sec);
	//print(tree.M, 0);
	printf("Unique: %d\n", tree.n);	
	freeNode(tree.M);
	return 0;
}
	
